<!DOCTYPE html>
<html lang="en">
  <head>
    <title>User Detail</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  </head>
  <body onload="onPageLoading()">
    <div class="container">
      <div class="row">
        <div class="jumbotron bg-light col-sm-6 mx-auto">
          <h3 class="text-center text-info mb-3">
            <span class="text-danger">DETAIL</span> USER
          </h3>
          <div class="row form-group">
            <label class="col-sm-3 col-form-label">STT</label>
            <div class="col-sm-9">
              <input
                type="text"
                class="form-control"
                id="inp-id"
                placeholder="..."
              />
            </div>
          </div>
          <div class="row form-group">
            <label class="col-sm-3 col-form-label">Name</label>
            <div class="col-sm-9">
              <input
                type="text"
                class="form-control"
                id="inp-name"
                placeholder="..."
              />
            </div>
          </div>
          <div class="row form-group">
            <label class="col-sm-3 col-form-label">User name</label>
            <div class="col-sm-9">
              <input
                type="text"
                class="form-control"
                id="inp-user-name"
                placeholder="..."
              />
            </div>
          </div>
          <div class="row form-group">
            <label class="col-sm-3 col-form-label">Email</label>
            <div class="col-sm-9">
              <input
                type="email"
                class="form-control"
                id="inp-email"
                placeholder="..."
              />
            </div>
          </div>

          <div class="row form-group">
            <label class="col-sm-3 col-form-label">Address</label>
            <div class="col-sm-9">
              <input
                type="text"
                rows="4"
                class="form-control"
                id="inp-address"
                placeholder="..."
              />
            </div>
          </div>
          <div class="row form-group">
            <label class="col-sm-3 col-form-label">Zip code</label>
            <div class="col-sm-9">
              <input
                type="text"
                class="form-control"
                id="inp-zip-code"
                placeholder="..."
              />
            </div>
          </div>
          <div class="row form-group">
            <label class="col-sm-3 col-form-label">Phone</label>
            <div class="col-sm-9">
              <input
                type="text"
                class="form-control"
                id="inp-phone"
                placeholder="..."
              />
            </div>
          </div>
          <div class="row form-group">
            <label class="col-sm-3 col-form-label">Company</label>
            <div class="col-sm-9">
              <input
                type="text"
                class="form-control"
                id="inp-company"
                placeholder="..."
              />
            </div>
          </div>
          <div class="row form-group">
            <button class="btn btn-success" id="btn-update">Update</button>
            <button class="btn btn-danger" id="btn-cancel">Cancel</button>
          </div>
        </div>
      </div>
    </div>
    <script>
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo hằng số, tham số TOÀN CỤC */
      var gBASE_URL = "https://jsonplaceholder.typicode.com/users/";
      var gInputId = $("#inp-id");
      var gInputName = $("#inp-name");
      var gInputUserName = $("#inp-user-name");
      var gInputEmail = $("#inp-email");
      var gInputAddress = $("#inp-address");
      var gInputZipCode = $("#inp-zip-code");
      var gInputPhone = $("#inp-phone");
      var gInputCompany = $("#inp-company");

      /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
      $(document).ready(function () {
        onPageLoading();
        //khai báo button click update
        $("#btn-update").on("click", onBtnUpdateClick);
        //khai báo button click cancel and come back to page
        $("#btn-cancel").on("click", onBtnCancelClick);
      });

      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      //load dữ liệu đổ vào form
      function onPageLoading() {
        "use strict";
        var vUserObj = { id: 0 };

        //read data from list post
        readDataUserObjectFromListAllUser(vUserObj);
        var vIsCheck = validateDataTransmit(vUserObj);
        if (vIsCheck) {
          callSeverByGetDataAjax(vUserObj);
        }
      }

      function onBtnUpdateClick() {
        //khai báo obj user
        var vUserObj = {
          id: 0,
          name: "",
          username: "",
          email: "",
          address: "",
          zipcode: "",
          phone: "",
          company: "",
        };

        //thu thập dữ liệu
        readDataUserObjForm(vUserObj);
        var vIsCheck = validateDataForm(vUserObj);
        if (vIsCheck) {
          callSeverByAjaxToUpdate(vUserObj);
        }
      }

      function onBtnCancelClick() {
        "use strict";
        window.location.href = "task 35.10.html";
      }

      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      //get ajax from list user
      function callSeverByGetDataAjax(paramUserIdObj) {
        const vAPI_URL = gBASE_URL + "/" + paramUserIdObj.id;
        $.ajax({
          url: vAPI_URL,
          type: "GET",
          dataType: "json",
          success: function (responseObject) {
            console.log(JSON.stringify(responseObject));
            loadDataToForm(responseObject);
          },
          error: function (ajaxContext) {
            //alert(ajaxContext.responseText);
            alert(
              "Bạn chưa có dữ liệu id truyền vào. Nhấn ok để quay về list comment."
            );
            window.location.href = "task 35.10.html";
          },
        });
      }

      // read data from web list user
      function readDataUserObjectFromListAllUser(paramUserIdObject) {
        var vUrlString = window.location.href;
        var vURL = new URL(vUrlString);
        var vId = vURL.searchParams.get("id");
        paramUserIdObject.id = vId;
      }

      //kiểm tra id truyền đến chưa
      function validateDataTransmit(paramUserIdObject) {
        if (paramUserIdObject.id === "") {
          alert("Dữ liệu cần truyền vào !");
          return false;
        }
        if (isNaN(paramUserIdObject.id)) {
          alert("Dữ liệu phải là số nguyên !");
          return false;
        }
        return true;
      }

      //read data user from form
      function readDataUserObjForm(paramUserObject) {
        paramUserObject.id = gInputId.val().trim();
        paramUserObject.name = gInputName.val().trim();
        paramUserObject.username = gInputUserName.val().trim();
        paramUserObject.email = gInputEmail.val().trim();
        paramUserObject.address = gInputAddress.val().trim();
        paramUserObject.zipcode = gInputZipCode.val().trim();
        paramUserObject.phone = gInputPhone.val().trim();
        paramUserObject.company = gInputCompany.val().trim();
      }

      //kiểm tra input form có để trống không
      function validateDataForm(paramUserObject) {
        if (paramUserObject.id === "") {
          alert("Id không được để trống !");
          return false;
        }
        if (isNaN(paramUserObject.id)) {
          alert("Id phải là số nguyên !");
          return false;
        }
        if (paramUserObject.name === "") {
          alert("Name không được để trống !");
          return false;
        }
        if (paramUserObject.username === "") {
          alert("User name không được để trống !");
          return false;
        }
        if (paramUserObject.email === "") {
          alert("Email không được để trống !");
          return false;
        }
        if (paramUserObject.address === "") {
          alert("Address không được để trống !");
          return false;
        }
        if (paramUserObject.zipcode === "") {
          alert("Zip code không được để trống !");
          return false;
        }
        if (paramUserObject.phone === "") {
          alert("Phone không được để trống !");
          return false;
        }
        if (paramUserObject.company === "") {
          alert("Phone không được để trống !");
          return false;
        }

        return true;
      }

      //load dữ liệu đến form
      function loadDataToForm(paramObj) {
        gInputId.val(paramObj.id);
        gInputName.val(paramObj.name);
        gInputUserName.val(paramObj.username);
        gInputEmail.val(paramObj.email);
        gInputAddress.val(
          paramObj.address.suite +
            ", " +
            paramObj.address.street +
            ", " +
            paramObj.address.city
        );
        gInputZipCode.val(paramObj.address.zipcode);
        gInputPhone.val(paramObj.phone);
        gInputCompany.val(paramObj.company.name);
      }

      //get ajax from list user
      function callSeverByAjaxToUpdate(paramUserObject) {
        const vAPI_URL = gBASE_URL + "/" + paramUserObject.id;
        $.ajax({
          url: vAPI_URL,
          type: "PUT",
          contentType: "application/json",
          data: JSON.stringify(paramUserObject), // added data type
          success: getUserDataByIdResponseSuccess,
          error: getUserDataByIdError,
        });
      }

      //call back function
      function getUserDataByIdResponseSuccess(responseObject) {
        console.log(responseObject);
        console.log(Object.entries(responseObject));
        alert("bạn đã update thành công! Nhấn ok sẽ trở về list form.");
        window.location.href = "task 35.10.html";
      }
      function getUserDataByIdError(ajaxContext) {
        alert(ajaxContext.responseText);
      }
    </script>
  </body>
</html>
